﻿@{
	/**/

	/**/

	ViewBag.Title = "User";
	Layout = "~/Areas/Admin/Views/Shared/_adminlayout.cshtml";
	int i = 1;
	var imagespath = System.Configuration.ConfigurationManager.AppSettings["imagesPath"] + "UserProfile/";
}
<link href="~/Content/Site.css" rel="stylesheet" />

<!-- Bootstrap core CSS -->
<link href="https://cdn.datatables.net/1.10.20/css/jquery.dataTables.min.css" rel="stylesheet" />
@*<link href="~/Content/jquery.dataTables.min.css" rel="stylesheet" />*@

<link href="~/Content/Site.css" rel="stylesheet" />
<link href="~/Content/frmUser.css" rel="stylesheet" />



<section class="wrapper site-min-height">

	<ol class="arrows">
		<li>
			<i class="fa fa-user"></i>
			@if (ViewContext.RouteData.Values["controller"].ToString() != "Home")
			{
				@Html.ActionLink("Users", "User", "Dashboard")
			}
		</li>
	</ol>
	<div style="display:flex;align-items:center">
		<h3 style="margin:0">Users</h3>
		<div class="mr-30" style="margin: 0 11px 0 auto;">
			<button type="button" class="btn btn-large btn-primary" id="NewUser" onclick="AddUser();">Add User</button>
		</div>
	</div>
	<hr>
	<label> Show/Hide Columns</label>
	<select id="showHide_id" class="form-control select.form-control" multiple="multiple" style="float:left;">
		<option value="1">Avatar</option>
		<option value="2">Full Name</option>
		<option value="3">User Name</option>
		<option value="4">Email</option>
		<option value="5">User Type</option>
		<option value="6">Login Type</option>
		<option value="7">Status</option>
		<option value="8">Flags</option>
		<option value="9">Country</option>
		<option value="10">Creation Date</option>
		<option value="11">Last activity date</option>
		<option value="12">Activity days</option>
		<option value="13">Art</option>
		<option value="14">Comments</option>
		<option value="15">Visited</option>
		<option value="16">Favourite</option>
		<option value="17">Likes</option>
		<option value="18">Art pending</option>
		<option value="19">Art rejected</option>
		<option value="20">Art approved</option>
		<option value="21">Art issue</option>
		<option value="22">Art deleted</option>
		<option value="23">Art flagged</option>
		<option value="24">Comments flagged</option>
	</select>

	<input type="image" id="btn_Filter" src="~/image/refresh_icon.png" style="float:right;width:34px" onclick="ClearData_User();" />

	@*<div style="float:right">
			Number of records to be dispalyed:
			<input type="number" id="txt_records" />
			<input type="button" id="show_row" class="" value="Show" />
		</div>*@
	<input type="button" id="hide_col" class="" value="Submit" />
	<br /><br /><br />
	@*Search
		<input type="text" id="txt_search" />*@
	<div id="client" style="overflow-x: scroll;">
	</div>
</section>

<script src="https://cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js"></script>
<script src="https://kendo.cdn.telerik.com/2019.3.1023/js/kendo.all.min.js"></script>
<script src="~/Scripts/Kendo/jquery.min.js"></script>
<link rel="stylesheet" href="https://kendo.cdn.telerik.com/2019.3.1023/styles/kendo.default-v2.min.css" />
<script src="~/Scripts/Kendo/kendo.all.min.js"></script>
<link href="~/Scripts/Kendo/kendo.default-v2.min.css" rel="stylesheet" />
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-multiselect/0.9.13/css/bootstrap-multiselect.css">
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-multiselect/0.9.13/js/bootstrap-multiselect.js"></script>

<body onbeforeunload="myfun()" id="bodyuser" onclick="">
</body>

<script>
    var grid = "";
    var imgpath = '@System.Configuration.ConfigurationManager.AppSettings["imagesPath"]' + "UserProfile/";
    var pagecount = 1;
    function myfun() {
        debugger;
        grid.dataSource.page(1);
    }

	$(document).ready(function () {
		debugger;
		
        localStorage.setItem("userID", "");
        $('#showHide_id').multiselect({
            includeSelectAllOption: true,
            nonSelectedText: 'Show/Hide column'
        });

        if (window.history && window.history.pushState) {
            window.history.pushState('forward', null, './User');
            $(window).on('popstate',function () {
                //window.location.href = 'http://localhost:58352/Admin/Dashboard/User';
                window.location.href = '@Url.Action("User","Dashboard")';
            });
        }
        $("#showHide_id").multiselect('selectAll', false);
		debugger;
		$('#pageload').show();
		var dataSource = @Html.Raw(Json.Encode(ViewData["UserList"]));
		$('#pageload').show();
        console.log(dataSource);
        $("#client").empty();
        grid = $("#client").kendoGrid({
            dataSource: {
                data: dataSource,
                schema: {
                    model: {
                        fields: {
							Art: { type: "number" },
							Comment: { type: "number" },
                            Visited: { type: "number" },
                            BookMark: { type: "number" },
                            artLike: { type: "number" },
                            ArtApproved: { type: "number" },
                            ArtPending: { type: "number" },
                            ArtIssue: { type: "number" },
                            ArtRejected: { type: "number" },
                            ArtDeleted: { type: "number" },
                            ActivityDays: { type: "string" },
                            ArtFlagged: { type: "number" },
                            CommentsFlagged: { type: "number" },
                            usr_CreatedDate: { type: "date" }
                        }
                    }
                }
            },
            filterable: true,

            pageable: {
                alwaysVisible: true,
                pageSize: 20
            },
            previousNext: true,
            scrollable: true,
            width: 800,
            resizable: true,
            toolbar: ["search"],
            sortable: {
                mode: "multiple",
                allowUnsort: true,
                showIndexes: true
            },
            columns: [{
                field: "SR",
                title: "Sr. No",
                width: 100,
                height:20,
                filterable: false
            },
              {
                  title: "Avatar",
                  width: 100,
                  height: 20,

                  template: function (dataItem) {

                      if (dataItem.usr_Image != null) {

                          var igm = imgpath + dataItem.usr_Image.replace(' ', '%20');
                      }
                      else {
                          var igm = t = imgpath + "user-image.png";
                      }
                      var imgdefalt=imgpath+"user-image.png";
                      if(dataItem.usr_Image!=null){
                          return  '<img src='+igm +' style="height:20px;width:20px; border-radius:50%" />'}
                      else{
                          return  '<img src='+imgdefalt +' style="height:20px;width:20px; border-radius:50%" />'}
                  }
              },
                 {
                     field: "usr_FullName",
                     title: "Full Name",
                     width: 200,
                     height: 20,
                     filterable: {
                         multi: true
                         // dataSource:function(dataItem){ return [{ usr_UserName: dataItem.usr_UserName }]}
                     },

                     template:function(dataItem){
                         if(dataItem.usr_LoginType==1){}
                         var UserId=dataItem.usr_UserId;
                         var FullName=dataItem.usr_FullName;
                         return '<a   style="color:#428bca;cursor: pointer" onclick="EditUser('+UserId+');">'+FullName+'</a>'
                     },
                 },
                 {
                     field: "usr_UserName",
                     title: "User Name",
                     width: 200,
                     height: 20,
                     filterable: {
                         multi: true
                     }
                 },
                 {
                     field: "usr_UserEmail",
                     title: "Email",
                     width: 200,
                     height: 20,
                     filterable: {
                         multi: true
                     }
				},
				{
					field: "RType",
					title: "User Type",
					//  hidden : '#if(isAdmin == false) {# false # }  else {# true #}#',
					// hidden: '#if(User Type == 2) {#true # }  else {# false #}#',
					// template: '#if(User Type == 2)  {# yes # }   else {# no #}#',
					width: 150,
					height: 20,
					filterable: {
						multi: true
					}
				},
				{
					field: "LType",
					title: "Login Type",
					width: 150,
					height: 20,

					filterable: {
						multi: true,

					},

				},
				{
					field: "SType",
					title: "Status",
					width: 100,
					height: 20,

					filterable: {
						multi: true
					}
				},
				{
					field: "Flag",
					title: "Flags",
					width: 250,
					height: 20,

					filterable: {
						multi: true
					}
				},
				 {
				     field: "Country",
				     title: "Country",
				     height: 20,

				     width: 120,
				     filterable: {
				         multi: true
				     }
				},
				{
				    field: "usr_CreatedDate",
					title: "Creation Date",
					//template: '#= kendo.toString(kendo.parseDate(usr_CreatedDate),"dd/MM/yy") #',
					width: 100,
					height: 20,
                    format: "{0:dd/mm/yy}",
                   
				},
				{
					field: "ActivityDate",
					title: "Last activity date",
					width: 100,
					height: 20,

					filterable: {
						multi: true
					},
				},
				{
					field: "ActivityDays",
					title: "Activity days",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},

				},
				{
					field: "Art",
					title: "Art",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},

				},
				{
					field: "Comment",
					title: "Comments",
					width: 80,

					filterable: {
						multi: true
					},

				},
				{
                      field: "Visited",
                      title: "Visited",
                      width: 80,
                      height: 20,

                      filterable: {
                          multi: true
                      },

                  },
                   {
                       field: "BookMark",
                       title: "Fav",
                       width: 80,
                       height: 20,

                       filterable: {
                           multi: true
                       },

                   },
                   {
                       field: "artLike",
                       title: "Likes",
                       width: 80,
                       height: 20,

                       filterable: {
                           multi: true
                       },
				},
				{
					field: "ArtPending",
					title: "Art pending",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "ArtRejected",
					title: "Art rejected",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
                   {
                       field: "ArtApproved",
                       title: "Art approved",
                       width: 80,
                       height: 20,

                       filterable: {
                           multi: true
                       },

                   },
                   {
                       field: "ArtIssue",
                       title: "Art issue",
                       width: 80,
                       height: 20,

                       filterable: {
                           multi: true
                       },

                   },
                   {
                       field: "ArtDeleted",
                       title: "Art deleted",
                       width: 80,
                       height: 20,
                       filterable: {
                           multi: true
                       },
                   },
                   {
                       field: "ArtFlagged",
                       title: "Art flagged",
                       width: 80,
                       height: 20,
                       filterable: {
                           multi: true
                       },

                   },
                   {
                       field: "CommentsFlagged",
                       title: "Comments flagged",
                       width: 80,
                       height: 20,
                       filterable: {
                           multi: true
                       },
                   }

            ]

        }).data("kendoGrid");
        var HideShowCol= localStorage.getItem("Col_hide");

        if (HideShowCol != null) {
            debugger;
            for(var i=1;i<=24;i++){
                grid.hideColumn(i);
            }
            HideShowCol=HideShowCol.toString();
            $.each(HideShowCol.split(","), function (i, e) {
                grid.showColumn(parseInt(e));

                $("#showHide_id option[value='" + e + "']").prop("selected", true);
            });

            var dataarray = HideShowCol.split(",");
            $("#showHide_id").val(dataarray);
            $("#showHide_id").multiselect("refresh");
           // localStorage.removeItem("Col_hide");
        }else{
            var selectval="1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24"
            selectval=selectval.toString();

            $.each(selectval.split(","), function (i, e) {

                $("#showHide_id option[value='" + e + "']").prop("selected", true);
            });
		}
		$('#pageload').hide();
        $("#hide_col").on("click", function () {
			debugger;
			$('#pageload').show();
            Save_FilterGrid();
            var kInput = document.querySelector(".k-input");
            var searchval = "";
            if(kInput!=undefined)
            {
                searchval = document.querySelector(".k-input").value;
            }
            pagecount = grid.dataSource.page();
            $("#showHide_id").val();
            var col_vals = $("#showHide_id").val();
            if (col_vals != null) {
                $("#client").empty();
                Bind_Kendo_Grid(dataSource);
                Set_FilterGrid();
                grid.dataSource.page(pagecount);
                if (searchval != null) {
                    $('.k-input').val(searchval);
                }
                for (var i = 1; i <= 24; i++) {
                    grid.hideColumn(i);
                }
                col_vals = col_vals.toString();
                localStorage.setItem("Col_hide", col_vals);
                $.each(col_vals.split(","), function (i, e) {
                    grid.showColumn(parseInt(e));
                });
            } else {
                $("#client").empty();
                $("#client").append('<div style="text-align:center;color:gray;font-size:23px;padding:12px;">No Data Found</div>');
			}
			$('#pageload').hide();
        });
        localStorage.setItem("ViewuserID", false);
        debugger;
        var FilterHiddn = localStorage.getItem("Save_FilterGrid");
        if (FilterHiddn != null) {
            Set_FilterGrid();
		}
		
    });
    function test_pagechange(e) {
        console.log(e);
    }

    function Bind_Kendo_Grid(dataSource) {
        debugger;
        grid = $("#client").kendoGrid({
            dataSource: {
                data: dataSource,
                schema: {
                    model: {
                        fields: {
							Art: { type: "number" },
							Comment: { type: "number" },
                            Visited: { type: "number" },
                            BookMark: { type: "number" },
                            artLike: { type: "number" },
                            ArtApproved: { type: "number" },
                            ArtPending: { type: "number" },
                            ArtIssue: { type: "number" },
                            ArtRejected: { type: "number" },
                            ArtDeleted: { type: "number" },
                            ActivityDays: { type: "number" },
                            ArtFlagged: { type: "number" },
                            CommentsFlagged: { type: "number" },
                            usr_CreatedDate: { type: "date" }
                        }
                    }
                }
            },
            filterable: true,

            pageable: {
                alwaysVisible: true,
                pageSize: 20
                // selectable: "row"
            },
            previousNext: true,
            scrollable: true,
            width: 800,

            resizable: true,
            toolbar: ["search"],
            // height: 550,
            sortable: {
                mode: "multiple",
                allowUnsort: true,
                showIndexes: true
            },
            columns: [{
                field: "SR",
                title: "Sr. No",
                width: 80,
                filterable: false

            },
			{
			    title: "Avatar",
			    width: 100,
			    template: function (dataItem) {

			        var igm = imgpath + dataItem.usr_Image;
			        var imgdefalt = imgpath + "user-image.png";
			        if (dataItem.usr_Image != null) {
			            return '<img src=' + igm + ' style="height:20px;width:20px; border-radius:50%" />'
			        }
			        else {
			            return '<img src=' + imgdefalt + ' style="height:20px;width:20px; border-radius:50%" />'
			        }
			    }
			},
			{
			    field: "usr_UserName",
			    title: "Full Name",
			    width: 200,

			    filterable: {
			        multi: true
			    },

			    template: function (dataItem) {
					if (dataItem.usr_LoginType == 1) {
					}
			        var UserId = dataItem.usr_UserId;
			        var FullName = dataItem.usr_FullName;
			        return '<a   style="color:#428bca;cursor: pointer" onclick="EditUser(' + UserId + ');">' + FullName + '</a>'
			    }
			},
                 {
                     field: "usr_UserName",
                     title: "User Name",
                     width: 200,
                     height: 20,
                     filterable: {
                         multi: true
                     }
                 },
			{
			    field: "usr_UserEmail",
			    title: "Email",
			    width: 200,

			    filterable: {
			        multi: true
			    }
				},
				{
					field: "RType",
					title: "User Type",
					//  hidden : '#if(isAdmin == false) {# false # }  else {# true #}#',
					// hidden: '#if(User Type == 2) {#true # }  else {# false #}#',
					// template: '#if(User Type == 2)  {# yes # }   else {# no #}#',
					width: 100,
					height: 20,
					filterable: {
						multi: true
					}
				},
				{
					field: "LType",
					title: "Login Type",
					width: 150,
					height: 20,

					filterable: {
						multi: true,

					},

				},
				{
					field: "SType",
					title: "Status",
					width: 100,
					height: 20,

					filterable: {
						multi: true
					}
				},
				{
					field: "Flag",
					title: "Flags",
					width: 250,
					height: 20,

					filterable: {
						multi: true
					}
				},
				{
					field: "Country",
					title: "Country",
					height: 20,

					width: 120,
					filterable: {
						multi: true
					}
				},
				{
				    field: "usr_CreatedDate",
					title: "Creation Date",
					//template: '#= kendo.toString(kendo.parseDate(usr_CreatedDate),"dd/MM/yy") #',
					width: 100,
					height: 20,
                    format: "{0:dd/mm/yy}",
				},
				{
					field: "ActivityDate",
					title: "Last activity date",
					width: 100,
					height: 20,

					filterable: {
						multi: true
					},
				},
				{
					field: "ActivityDays",
					title: "Activity days",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},

				},
				{
					field: "Art",
					title: "Art",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},

				},
				{
					field: "Comment",
					title: "Comments",
					width: 80,

					filterable: {
						multi: true
					},

				},
				{
					field: "Visited",
					title: "Visited",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "BookMark",
					title: "Fav",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "artLike",
					title: "Likes",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},
				},
				{
					field: "ArtPending",
					title: "Art pending",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "ArtRejected",
					title: "Art rejected",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "ArtApproved",
					title: "Art approved",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "ArtIssue",
					title: "Art issue",
					width: 80,
					height: 20,

					filterable: {
						multi: true
					},

				},
				{
					field: "ArtDeleted",
					title: "Art deleted",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},
				},
				{
					field: "ArtFlagged",
					title: "Art flagged",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},

				},
				{
					field: "CommentsFlagged",
					title: "Comments flagged",
					width: 80,
					height: 20,
					filterable: {
						multi: true
					},
				}

            ]

        }).data("kendoGrid");
    }

    function UserFilter() {
        var MostDropdown = $("#mostDropdown").val();
        var StartDate = $("#StartDt").val();
        var EndDate = $("#EndDt").val();
        var CommentCountDrop = $("#CommentCountDrop").val();
        var LoginCountDrop = $("#LoginCountDrop").val();
        var LastLoginDt = $("#LastLoginDt").val();
        var LoginSocialDrop = $("#LoginSocialDrop").val();
        var failedAttempDrop = $("#failedAttempDrop").val();
        var DownloadsDrop = $("#DownloadsDrop").val();

        var data = {
            lastfilterAlfa: lastfilterAlfa,
            MostDropdown: mostDropdown,
            StartDate: StartDate,
            EndDate: EndDate,
            CommentCountDrop: CommentCountDrop,
            LoginCountDrop: LoginCountDrop,
            LastLoginDt: LastLoginDt,
            LoginSocialDrop: LoginSocialDrop,
            failedAttempDrop: failedAttempDrop,
            DownloadsDrop: DownloadsDrop
        }
        console.log(data);
    }

    function getFullProfile(id) {
        localStorage.setItem("userId", id);
        window.location.href = '@Url.Action("UserProfileDetail", "Dashboard", new { area = "admin" })';
    }
    function UpdateUserStatus(id) {
        var Userstatus = false;
        swal({
            title: "Are you sure? ",
            text: "Want to update user status",
            icon: "warning",
            buttons: true,
            dangerMode: true,
        })
    .then((willDelete) => {
        if (willDelete) {

            var chid = "#check_" + id;
            if($(chid).prop('checked')){
                Userstatus = true
            }
            else {
                Userstatus = false

            }

            var data1 = {
                usr_UserId: id,
                usr_Status:Userstatus
            }

            $.ajax({
                type: "POST",
                async: false,
                dataType: 'json',
                url: '@Url.Action("UpdateUserStatus", "Dashboard", new { area = "admin"})',
                data: data1,
                success: function (data) {

                    if (data.status == "success") {
                    }
                }

            });
        } else {
            swal("User status not changed");
            var url = '@Url.Action("User", "Dashboard", new { area = "admin"})';
            window.location.href = url;
        }
    });
    }

	function AddUser() {
		$('#pageload').show();
        Save_FilterGrid();
        localStorage.setItem("userID", "");
        var url = '@Url.Action("AddUser", "Dashboard", new { area = "admin"})';
        window.location.href = url;
    }

    function Save_FilterGrid() {
        debugger;
        var filter = grid.dataSource.filter();
        //if(filter != undefined)
        //{
            localStorage.setItem("Save_FilterGrid", JSON.stringify(filter));
            localStorage.setItem("Save_SearchGrid", document.querySelector(".k-input").value);
            var currentPage = grid.dataSource.page();
            localStorage.setItem("Save_Paging", currentPage);
       // }
    }
    function Set_FilterGrid() {
        debugger;
        var ResetData = localStorage.getItem("Save_FilterGrid");
        var Save_SearchGrid = localStorage.getItem("Save_SearchGrid");
        var currentPage = localStorage.getItem("Save_Paging");

        if (ResetData != "undefined") {
            grid.dataSource.filter(JSON.parse(ResetData));
            grid.refresh();
            $('.k-input').val(Save_SearchGrid);
            grid.dataSource.page(currentPage);
        }

        localStorage.removeItem("Save_FilterGrid");
        localStorage.removeItem("Save_SearchGrid");
        localStorage.removeItem("Save_Paging");

    }
	function EditUser(id) {
		debugger;
		$('#pageload').show();
        Save_FilterGrid();
		localStorage.setItem("userID", id);
		localStorage.setItem("LoginType", id);


        var url = '@Url.Action("AddUser", "Dashboard", new { area = "admin"})';
        window.location.href = url;
    }
    function viewUser(id) {
        localStorage.setItem("userID", id);
        localStorage.setItem("ViewuserID", true);

        var url = '@Url.Action("AddUser", "Dashboard", new { area = "admin"})';

        window.location.href = url;
    }
    function DeleteUser(id) {
        swal({
            title: "Are you sure? ",
            text: "You want to Delete this record?",
            icon: "warning",
            buttons: true,
            dangerMode: true,
        })
            .then((willDelete) => {
                if (willDelete) {

                    var data1 = {
                        usr_UserId: id

                    }
                    $.ajax({
                        type: "POST",
                        dataType: "json",
                        url: '@Url.Action("DeleteUser", "Dashboard",new { area = "Admin"})',
                        data: data1 ,
                        success: function (data) {

                            console.log(data.status);
                            if (data.status == "success") {
                                swal("User deleted successfully", {
                                    icon: "success",
                                });
                                window.location.reload(true);

                            }
                        }
                    });

                } else {
                    swal("Your Art  is safe!");
                }
            });
	}
	function ClearData_User() {
		localStorage.removeItem("Save_FilterGrid");
		localStorage.removeItem("Save_SearchGrid");
		localStorage.removeItem("Save_Paging");
		localStorage.removeItem("Col_hide");
		
		window.location.href = '@Url.Action("User", "Dashboard")';
	}
</script>